#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "UObject/NoExportTypes.h"
#include "FlamePillarExitGateMinigame.generated.h"

class AEscapeDoor;
class UK37VampireAbility;
class UK37FlamePillarData;
class UBoxComponent;

UCLASS(Blueprintable)
class THEK37_API AFlamePillarExitGateMinigame : public AActor
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AEscapeDoor* _attachedEscapeDoor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, Export, meta=(AllowPrivateAccess=true))
	UK37VampireAbility* _cachedOwningAbility;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UK37FlamePillarData* _flamePillarData;

public:
	UFUNCTION(BlueprintPure)
	UBoxComponent* GetExitArea() const;

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintAuthorityOnly)
	void Authority_StartMinigame();

protected:
	UFUNCTION(BlueprintCallable, BlueprintAuthorityOnly)
	void Authority_SpawnFlamePillarAtLocation(const FVector& location);

public:
	AFlamePillarExitGateMinigame();
};

FORCEINLINE uint32 GetTypeHash(const AFlamePillarExitGateMinigame) { return 0; }
